package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import org.flixel.*;

		public class Preloader extends FlxPreloader
		{
			public var text:TextField;
			public var rect:Rectangle;
			public var shape:Shape;
			
			public function Preloader()
			{
				className = "HelloWorld";
				super();
			}						
			
			override protected function create(): void 
			{
				this.minDisplayTime=1;
				super.create();
				this.minDisplayTime=1;
				
				// The buffer, add every graphics on it.
				_buffer = new Sprite();
				_buffer.width = stage.stageWidth;
				_buffer.height = stage.stageHeight;
				_buffer.scaleX = 2;
				_buffer.scaleY = 2;
				addChild(_buffer);
				
				// Background
				_width = stage.stageWidth/_buffer.scaleX;
				_height = stage.stageHeight/_buffer.scaleY;
				_buffer.addChild(new Bitmap(new BitmapData(_width, _height, false, 0xff000000)));				
				
				// This shows the bar.
				//_bmpBar = new Bitmap(new BitmapData(1,7,false,0xff000000));
				//_bmpBar.x = 4;
				//_bmpBar.y = _height-11;
				//_buffer.addChild(_bmpBar);
				
				// This displays the percentage that has been loaded.
				_text = new TextField();
				_text.defaultTextFormat = new TextFormat("system",30,0xffffffff);	
				_text.embedFonts = true;
				_text.selectable = false;
				_text.multiline = false;
				_text.x = 2;
				_text.y=_height/2-Number(_text.defaultTextFormat.size)/2;
///				_text.y = _bmpBar.y - 40;
				_text.width = _width;		
				_text.defaultTextFormat.align=flash.text.TextFormatAlign.CENTER;
				_buffer.addChild(_text);
			}
			
			override protected function update(Percent: Number): void 
			{
				//_bmpBar.scaleX = Percent*(_width-8);
				if(Percent >= 1)
				{
					_text.text = "Completed";
					_text.setTextFormat(_text.defaultTextFormat);
					return;
				}
				_text.text = "Loading: " + FlxU.floor(Percent*10)*10+"%";
				_text.setTextFormat(_text.defaultTextFormat);
			}
		}
}